\NeedsTeXFormat{LaTeX2e}
\ProvidesClass{geophysics}[1998/01/20 v0.1 Geophysics paper]

\LoadClass[alone,11pt]{sep2e}

\renewcommand{\baselinestretch}{2.0} % double spacing

\renewcommand{\author}[1]{%
\begin{centering}
  \textbf{#1} \\
  \emph{Stanford Exploration Project, Mitchell Bldg., Department of
    Geophysics, \\ Stanford University, Stanford, CA 94305-2215} \\
  (\today) \\
\end{centering} 
}

\renewcommand{\ABS}[1]{%
\section{ABSTRACT} 
#1
}

\pagestyle{plain}
\thispagestyle{plain}

\setcounter{totalnumber}{1}

\AtEndDocument{%
\setcounter{figure}{0}%
\renewcommand{\thefigure}{\arabic{figure}}%
\ifthenelse{\value{table} > 0}{\listoftables}{}%
\listoffigures}

% copied from article.cls and hacked
\long\def\@makecaption#1#2{%
  \vskip\abovecaptionskip
  \sbox\@tempboxa{#1.}%
  \ifdim \wd\@tempboxa >\hsize
    #1.\par
  \else
    \global \@minipagefalse
    \hb@xt@\hsize{\hfil\box\@tempboxa\hfil}%
  \fi
  \vskip\belowcaptionskip}

% copied from article.cls and hacked
\renewcommand\listoffigures{%
    \section{\listfigurename
      \@mkboth{\MakeUppercase\listfigurename}%
              {\MakeUppercase\listfigurename}}%
    \@starttoc{lof}%
    }

\renewcommand\listoftables{%
    \section{\listtablename
      \@mkboth{\MakeUppercase\listtablename}%
              {\MakeUppercase\listtablename}}%
    \@starttoc{lot}%
    \clearpage
    }

% to suppress page numbers from lof
\renewcommand*{\l@figure}[2]{%
  \setlength{\@tempdima}{2.3em}%
  \noindent\hspace*{1.5em}#1\hfil\newline}
\let\l@table\l@figure

\renewcommand{\plot}[4][X]{%
\AtEndDocument{%
\begin{figure}[p]
\centering
\includegraphics[#3]{\fig@file{#2}}
\caption[#4]{}
\expanded@label{\papername}{fig:#2}
\end{figure}\clearpage}}

\newcommand{\tabl}[1]{%
\AtEndDocument{%
\begin{table}[p]
#1
\end{table}\clearpage}}

\renewcommand{\sideplot}[4][.]{\plot{#2}{#3}{#4}}
\renewcommand{\activeplot}[5][.]{\plot{#2}{#3}{#5}}
\renewcommand{\activesideplot}[5][.]{\plot{#2}{#3}{#5}}





