#include <sitedef.h>
#if defined (HAVE_MOTIF) || defined(HAVE_ATHENA)
/*
help object
called for command line selfdoc or
portions for menu help
*/
#include <stdio.h>
#include <string.h>
#include<rick.h>

char *help = "\n\
Ricksep - display cubic array of data in XWindows-Motif\n\
\n\
USAGE: Ricksep in=datafile [ data pars ] [ display pars ]\n\
\n\
DATA ARGUMENTS:\n\
in=datafile n1= n2= n3=     bytes format (SEPlib)\n\
          byte array without header\n\
in=datafile n1= n2= n3= esize=4   float format\n\
          float array without header\n\
\n\
DATA PARAMETERS:\n\
  For all parameters: \n\
		First check command line with dataset number (e.g) for the  \n\
    second dataset title2=.      \n\
    second title, third history file. \n\
in=\"stdin\"    name of input file\n\
n1= n2= n3= n4=1 n5=1 length of three dimensions, n1 is fastest, e.g. time\n\
o1=0, o2=0 ...    first sample value in each dimension\n\
d1=1 d2=1 ...   sample increment in each dimension\n\
label1=\"n1\" ...   label for each dimension\n\
title=in    dataset title\n\
value=\"sample\"  name for values on colorbar\n\
esize=1     data samples are =1 for bytes or =4 for floats\n\
For esize=1 data \n\
  pclip=255   positive clip value; high= and clip= are synonyms\n\
  nclip=1     negative clip value; low= and clip= are synonyms\n\
For esize=4 data \n\
 tpow,gpow,pclip,clip,min,max - Cliping parameters \
\n\
PICK PARAMETERS:\n\
 For additional datasets: param# overides param \n\
npick=25000   maximum number of picks used\n\
pick=file     file containing picks \n\
picksize=5    size of pick mark to display \n\
run_cor=0     wheter or to run correloation when doing auto picking \n\
search_radius=5 Radius to search arround when doing auto picking \n\
npaths=3       Number of paths to search when doing VIT path \n\
j_display=8    Sampling of picks to display when doing auto picking \n\
nwind_cor=8    Half witdth of correlation window when doing auto picking \n\
ind_axis=1     Indepenant axis when doing auto picking  \n\
max_tol=1.02   First tolerance when doing auto picking by growing \n\
min_tol=.96    Minimum tolerance when doing auto picking by growing \n\
dtol=.022      Sampling of tolerance when doing auto picking by growing \n\
showypicks=1  Wheter (1) or not (0) to show picks \n\
display_method=0 Method (0) puts marks at each location \n\
                 (1) Lines drawn between picks along dependant axis \n\
pickrange=5    Range in which we can see nearby picks  \n\
DISPLAY PARAMETERS:\n\
   For multiple views: style, orient, origin, norder, and shape \n\
    style1 corresponds to the second view, style2 third view, etc.\n\
\n\
ncolor=128  For now we can only display up to 128\n\
width=600 height=600  pixel dimension (> 64) or fraction of screen (<= 1.0)\n\
style=\"cube\"    view is front, side, top, plan, array, picks, cube, fence, or transparent\n\
orient=\"front\"    orient is front, side, top\n\
origin=\"minimum\"    frames set to middle or minimum\n\
transp=0    if 1, transpose down and across\n\
shape=\"fit\"   shape fits screen, true, or pixel\n\
movie=\"off\"   run movie in up, down, left, right, in, or out direction\n\
color=\"gray\"    color is gray, straw, flag, tiger, blue, or rainbow\n\
contrast=\"50\"   contrast is between 0 and 100\n\
norder=1,2,3,4,5 data axis corresponding to each view axis \n\
          view axes are DOWN, ACROSS, DEEP, AXIS4,AXIS5   \n\
font=     alternative XWindows font; default bold-courier-20\n\
\n\
DO man Ricksep for more complete description\
END \n\
\n";

/*
MULTIPLE VIEW PARAMETERS: \n\
nview=1  number of different views. Numbering of views starts with 0 \n\
dataX =  tag for dataset beyond the first (e.g. data1=comparison.H) \n\
nview_dim=[nview,1]  The orientation of the differnt views (across,down)\n\
view_ratio_x=[1./nview[0]] The amount of space in x for each view \n\
view_ratio_y=[1./nview[1]] The amount of space in y for each view \n\
viewX_data = [in]   The data to be used in a given view \n\
\n\
VELOCITY ANALYSIS PARAMETERS \n\
  Set mode=velan. Make sure to have vscan and nmoed set in \n\
   viewx_data.  Right click with key=l is useful. \n\
oversample=10 Oversample rate for velocity analysis \n\
ignore=0.  How much of eary times to ignore \n\
smute=1.5  Stratch factor begin muting \n\
nsmooth=ovesample*2+1 Amount to smooth semblance \n\
no_sem=0  Whether (1) or not (0) to calculate semblance \n\
v0=1.5  Initial velocity to scan over \n\
nv=50   Number of velocities to scan over \n\
dv=(3.5-v0)/(nv-1) Sampling rate of velocity \n\
\n\
FILE FORMATS:\n\
seplib, bytes input data set: (user supplied)\n\
  2-D of 3-D array of unsigned byte integers 0-255.\n\
  Use segy2movie to convert segy.\n\
  Use Byte to convert seplib floating point.\n\
seplib, float input data set: (user supplied)\n\
  2-D of 3-D array of float numbers\n\
par file: (user supplied or generated by Save State menu)\n\
  List of parameters in name=value form. Free format.\n\
  Last of duplicates used.\n\
\n\
WINDOWS:\n\
(1) Menubar on top.\n\
(2) Message window below menubar.\n\
(3) Control panel below message window.\n\
(4) Color spectrum below control panel.\n\
    Line shows relative data sample distribution.\n\
    Bar shows last pick value or range of values.\n\
    Mouse click-drag-up specifies a value range.\n\
(5) Resizable image window.  Responds to following mouse clicks:\n\
\n\
NAVIGATION MOUSE USAGE:\n\
LEFT: zoom; MIDDLE: navigate; RIGHT: pick.\n\
LEFT click-drag-up: zoom window.\n\
LEFT click-drag-up + 'h' key: zoom horizontal only.\n\
LEFT click-drag-up + 'v' key: zoom vertical only.\n\
LEFT click-drag-up in ARRAY window: those panels.\n\
'm' key: move back one frame.\n\
'n' key: move forward one frame.\n\
MIDDLE click: select cross frames.\n\
MIDDLE click-drag-up: select an animation range.\n\
PICKING MOUSE USAGE:\n\
RIGHT click: pick a point on the image.\n\
RIGHT click + 'a' key: add a point to end of pick.\n\
RIGHT click + 'c' key: bring up pick menu \n\
RIGHT click + 'd' key: delete nearest point in pick.\n\
RIGHT click + 'q' key: Print information about nearest pick \n\
RIGHT click + '?' key: Print information about nearest pick \n\
RIGHT click + 'l' key: Display a line across all panels at selected \n\
                         indepenent axis value \n\
RIGHT drag  + 'e' key: delete a window of picks.\n\
RIGHT drag  + 'g' key: Do a 2-D growing within selected window. Fixing \n\
                        preselected points \n\
RIGHT drag  + 'p' key: Do a  line between two points that has the \n\
                         best correlation \n\
RIGHT click + 'f' key: Perform region growing in the currently viewable \n\
                         cube. \n\
RIGHT click + 'b' key: Snap all points with current symbol to best correlation\n\
ANNOTATE MOUSE USAGE:\n\
  All actions only available when annotation option selected. \n\
RIGHT click + 'q' key:  Modify nearest annotation object \n\
LEFT  drag:  Create an oval at the given location \n\
Middle drag:  Create a rectangle at the given location \n\
RIGHT click + 'a' key:  Add point to polyline object \n\
RIGHT click + 'f' key:  Finish a polyline object \n\
OTHER MOUSE USAGE:\n\
RIGHT click + 's' key: Create sub-volume \n\
COLORBAR ANY click-drag-up: replace sub-volume range with this new range.\n\
\n\
INTERACTIVE CONTROLS:\n\
MAIN FUNCTIONS: Interface to system\n\
  \"Main\"  \"Redraw\" -- refresh damaged screen\n\
  \"Main\"  \"Write vgrid file (floats)\" -- save data files as floats in seplib/vgrid format\n\
  \"Main\"  \"Write vgrid file (bytes)\" -- save data files as bytes in seplib/vgrid format\n\
  \"Main\"  \"Write parameter restart file\" -- create a parameter restart file\n\
  \"Main\"  \"Debug\" -- dump various arrays for programmer debugging\n\
  \"Main\"  \"Quit\"\n\
STYLE FUNCTIONS: Select a style and set attributes\n\
  \"Style\"   \"Front (2D)\" -- Front face of data cube\n\
  \"Style\"   \"Side (2D)\" -- Side face of data cube\n\
  \"Style\"   \"Top (2D)\" -- Top face of data cube\n\
  \"Style\"   \"Plan (2D)\" -- All three cube faces\n\
  \"Style\"   \"Array (3D) ...\" -- Array of front faces- up to a hundred\n\
  \"Style\"   \"Pick (3D) ...\" -- Array of picked faces\n\
  \"Style\"   \"Cube (3D)\" -- Cube view\n\
  \"Style\" \"Fence (3D) ...\" -- Show intersecting faces\n\
  \"Style\"   \"Transparent (3D) ...\" -- Transparent volume\n\
  \"Array Panel\" \"Direction\" <four axes> -- Select through direction\n\
  \"Array Panel\" \"Down\" -- Panels in down direction\n\
  \"Array Panel\" \"Across\" -- Panels in across direction\n\
  \"Array Panel\" \"Start\" -- First panel\n\
  \"Array Panel\" \"Delta\" -- Panel increment\n\
  \"Array Panel\" \"End\" -- Last panel; sets delta\n\
  \"Array Panel\" \"Draw\" -- Draw with new parameters\n\
  \"Array Panel\" \"Close\" -- Close control panel\n\
  \"Array Panel\" \"LEFT MOUSE SELECTS PANEL RANGE\n\
  \"Fence Panel\" \"Toggle Front\" -- Toggle front plane on\n\
  \"Fence Panel\" \"Toggle Side\" -- Toggle side plane on\n\
  \"Fence Panel\" \"Toggle Top\" -- Toggle top plane on\n\
  \"Fence Panel\" \"Transparency\" -- Set transparency threshhold\n\
  \"Fence Panel\" \"Draw\" -- Draw with new parameters\n\
  \"Fence Panel\" \"Close\" -- Close control panel\n\
  \"Transparency Panel\"  \"Min\" -- Set minimum transparency value\n\
  \"Transparency Panel\"  \"Max\" -- Set maximum transparency value\n\
  \"Transparency Panel\"  \"Transp\" -- Set transparency value\n\
  \"Transparency Panel\"  \"Draw altogether\" -- Update screen once\n\
  \"Transparency Panel\"  \"Draw tenth blocks\" -- Update screen ten times\n\
  \"Transparency Panel\"  \"Draw each plane\" -- Update screen continuously\n\
  \"Transparency Panel\"  \"Draw\" -- Draw with new parameters\n\
  \"Transparency Panel\"  \"Close\" -- Close control panel\n\
ORIENT FUNCTIONS: change way axes point; 2-D are in-plane\n\
  \"Orient\"  \"Transpose axes (1-2)\n\
  \"Orient\"  \"Transpose axes (1-3)\n\
  \"Orient\"  \"Transpose axes (1-4)\n\
  \"Orient\"  \"Transpose axes (1-5)\n\
  \"Orient\"  \"Transpose axes (2-3)\n\
  \"Orient\"  \"Transpose axes (2-4)\n\
  \"Orient\"  \"Transpose axes (2-5)\n\
  \"Orient\"  \"Transpose axes (3-4)\n\
  \"Orient\"  \"Transpose axes (3-5)\n\
  \"Orient\"  \"Transpose axes (4-5)\n\
  \"Orient\"  \"<-Down-> (2-D)\" -- Reversal\n\
  \"Orient\"  \"<-Across-> (2-D)\" -- Reversal\n\
  \"Orient\"  \"<-Deep-> (3-D)\" -- Reversal\n\
  \"Orient\"  \"Orientation Menu\" -- What data axis and frames to display \n\
  \"Orient\"  \"Frames to Origin\" -- Cross frames to start of origin of each axis\n\
  \"Orient\"  \"Frames in Middle\" -- Cross frames in middle of each frame\n\
  \"Orient\"  \"Labels Set ..\" -- Control panel to adjust labeling\n\
  \"Orient\"  \"Reset Initial\"\n\
SIZE FUNCTIONS: set size and shape policy\n\
  \"Size\"  \"Fit Screen\" -- Front fills 2/3s screen; sides 1/3\n\
  \"Size\"  \"True Proportions\"\n\
  \"Size\"  \"Sample per Pixel\"\n\
  \"Size\"  \"Interpolate\" -- Improves large magnifications\n\
  \"Size\"  \"Size Set ..\" -- Launch size setting control panel\n\
  \"Size Set\"  \"Minimum\" -- Minimum sample/value along axis\n\
  \"Size Set\"  \"Maximum\" -- Maximum sample/value along axis\n\
  \"Size Set\"  \"Frame\" -- Frame sample/value along axis\n\
  \"Size Set\"  \"Pixels\" -- Pixels along axis\n\
  \"Size Set\"  \"Draw\" -- Draw these size settings\n\
  \"Size Set\"  \"Current\" -- Restore current size settings\n\
  \"Size Set\"  \"Initial\" -- Fill in initial settings\n\
  \"Size Set\"  \"Close\" -- Close size settings panel\n\
  \"Size\"  \"Reset Initial\"\n\
  \"Size\"  \"LEFT MOUSE BOX ZOOMS\" -- interactive magnification\n\
  \"Size\"  \"+ 'h' KEY ONLY HORZ\" -- constrain to horizontal\n\
  \"Size\"  \"+ 'v' KEY ONLY VERT\" -- constrain to vertical\n\
MOVIE FUNCTIONS: go to part of the cube; run movies\n\
  \"Movie\" \"Reset Bounds\" -- Movie loop traverses full cross face\n\
  \"Movie\" \"High Speed\" -- Frames are stored in displat terminal\n\
  \"Movie\" BUTTON \"GO\" -- Start movie\n\
  \"Movie\" BUTTON \"NO\" -- Stop movie\n\
  \"Movie\" BUTTON \" z \" -- Run/step in direction\n\
  \"Movie\" BUTTON \" Z \" -- Run/step out direction\n\
  \"Movie\" BUTTON \" < \" -- Run/step left direction\n\
  \"Movie\" BUTTON \" > \" -- Run/step right direction\n\
  \"Movie\" BUTTON \" ^ \" -- Run/step up direction\n\
  \"Movie\" BUTTON \" v \" -- Run/step down direction\n\
  \"Movie\" SLIDER \" Speed \" -- Delay between frames\n\
  \"Movie\" \"MIDDLE MOUSE CLICK Reset cross framesFRAMES\" -- X\n\
  \"Movie\" \"MIDDLE MOUSE DRAG MOVIE BOUNDS\" -- Set movie range\n\
COLOR FUNCTIONS: set color, contrast, and transparency\n\
  \"Color\" \"Gray\" -- Grayscale\n\
  \"Color\" \"Straw\" -- Blue and yellow\n\
  \"Color\" \"Flag\" -- Red, white and blue\n\
  \"Color\" \"Tiger\" -- Red, white and black\n\
  \"Color\" \"Blue\" -- Blue and white\n\
  \"Color\" \"Rainbow\" -- Multi-colored\n\
  \"Color\" \"Graybow\" -- Gray plus multi-colored\n\
  \"Color\" \"Overlay\" <color-list> -- Overlay lines and text\n\
  \"Color\" \"Mark\" <color-list> -- Pick color\n\
  \"Color\" \"Background\" <color-list> -- Screen background color\n\
  \"Color\" \"Flip Polarity\" -- of data-> color\n\
  \"Color\" \"Reset Contrast\" -- No skew or zero point contrast\n\
  \"Color\" SLIDER \"CONTRAST\" -- Shift color table skew\n\
  \"Color\" SLIDER \"CONTRAST0\" -- Shift color table zero point\n\
  \"Color\" SLIDER \"TRANSPARENCY\" -- Change transparency value\n\
  \"Color\" BUTTON \"Reset\" -- Reset initial contrast\n\
PICK FUNCTIONS: set picking behavior\n\
  \"Pick\"  \"Clear Current Line\" -- Erase pick line or sub-volume\n\
  \"Pick\"  \"Write pick file\" -- Write to pick= now\n\
  \"Pick\"  \"Read pick file\" -- Read from pick= now\n\
  \"Pick\"  \"RIGHT MOUSE MAKES PICK\" -- right mouse button manipulates picks\n\
  \"Pick\"  \"+ 'a' KEY ADDS POINT TO \"\n\
  \"Pick\"  \"+ 'i' KEY INSERTS POINT BETWEEN NEAREST POINTS\"\n\
  \"Pick\"  \"+ 'm' KEY MOVES NEAREST POINT\"\n\
  \"Pick\"  \"+ 'd' KEY DELETES NEAREST POINT\"\n\
  \"Pick\"  \"+ 's' KEY + DRAGGING PICKS SUB-VOLUME\"\n\
EDIT FUNCTIONS: edit grid sub-volume\n\
  \"Edit\"  \"Clear Sub-volume pick\" -- Clear current subvolume\n\
  \"Edit\"  \"Smooth Sub-volume\" -- Smooth sub-volume to boundary value\n\
  \"Edit\"  \"Undo Smooth\" -- Restore sub-volume\n\
  \"Edit\"  \"Grade Sub-volume\" -- Grade sub-volume to boundary plane values\n\
  \"Edit\"  \"Undo grade\"\n\
  \"Edit\"  \"Sub-volume Neighborhood\" <6, 18, 26> -- Cube connectivity of sub-volume\n\
  \"Edit\"  \"COLOR BAR MOUSE SETS SMOOTH RANGE\"\n\
SECTION FUNCTION: plot various sections through the data\n\
  \"Section\" \"On screen wiggle plot ...\" \"Front, side or top plane\"\n\
  \"Section\" \"On screen contour plot ...\"  \"Front, side or top plane\"\n\
  \"Section\" \"On screen grey profile ...\" \"Down, across, or deep profile\"\n\
  \"Section\" \"Print wiggle plot ...\" \"Front, side or top plane\"\n\
  \"Section\" \"Print contour plot ...\"  \"Front, side or top plane\"\n\
  \"Section\" \"Print grey profile ...\" \"Down, across, or deep profile\"\n\
  \"Section\" \"Cubeplot ...\" \"Plot or print \"\n\
  \"Section\" \"Output ...\" \"View or commands \"\n\
  \"Section\" \"Save section in file ...\"  \"Front, side or top plane\"\n\
  \"Section\" \"Save profile in file ...\"  \"Save down, across, or deep profile\"\n\
  \"Section\" \"PLANES AND PROFILES ARE SELECTED AT CROSS-HAIRS\"\n\
STATUS FUNCTIONS: print parameters and state variables\n\
  \"Status\"  \"Dataset\" -- Dataset parameters\n\
  \"Status\"  \"Data Values\" -- Data value parameters\n\
  \"Status\"  \"Data Axis0\" -- Value/color axis\n\
  \"Status\"  \"Data Axis1\" -- Fast axis, usually time\n\
  \"Status\"  \"Data Axis2\" -- Second data axis, usually CDP\n\
  \"Status\"  \"Data Axis3\" -- Slow axis, usually section\n\
  \"Status\"  \"Data Axis4\" -- Slow axis, usually offset\n\
  \"Status\"  \"Data Values\" -- Data value parameters\n\
  \"Status\"  \"Data Axis0\" -- Value/color axis\n\
  \"Status\"  \"Data Axis1\" -- Fast axis, usually time\n\
  \"Status\"  \"Data Axis2\" -- Second data axis, usually CDP\n\
  \"Status\"  \"Data Axis3\" -- Slow axis, usually section\n\
  \"Status\"  \"Data Axis4\" -- Slow axis, usually offset\n\
  \"Status\"  \"Data Axis5\" -- Slow axis, unused\n\
  \"Status\"  \"Style\" -- View parameters\n\
  \"Status\"  \"Down Axis\" -- View down axis parameters\n\
  \"Status\"  \"Across Axis\" -- View across axis parameters\n\
  \"Status\"  \"Deep Axis\" -- View deep axis parameters\n\
  \"Status\"  \"Extra Axis\" -- View extra axis parameters\n\
  \"Status\"  \"Color Axis\" -- Colorbar axis parameters\n\
  \"Status\"  \"Color\" -- Color and contrast parameters\n\
  \"Status\"  \"Render\" -- Rendering parameters\n\
  \"Status\"  \"Draw\" -- Draw screen parameters\n\
  \"Status\"  \"Mouse Buttons\" -- Mouse button functions\n\
  \"Status\"  \"Movie\" -- Movie parameters\n\
  \"Status\"  \"Pick\" -- Pick parameters\n\
  \"Status\"  \"Pick List\" -- Current pick line parameters\n\
  \"Status\"  \"sub-volume\" -- Current mark sub-volume\n\
  \"Status\"  \"Frame List\" -- List of screen frames\n\
HELP FUNCTIONS: print self documentation from various places\n\
  \"Help\"  \"Command Line Args\"\n\
  \"Help\"  \"File Formats\"\n\
  \"Help\"  \"Windows\"\n\
  \"Help\"  \"Mouse Usage\"\n\
  \"Help\"  \"Main Functions\"\n\
  \"Help\"  \"Style Functions\"\n\
  \"Help\"  \"Orient Functions\"\n\
  \"Help\"  \"Size Functions\"\n\
  \"Help\"  \"Movie Functions\"\n\
  \"Help\"  \"Color Functions\"\n\
  \"Help\"  \"Picking Functions\"\n\
  \"Help\"  \"Status Functions\"\n\
EXAMPLES \n\
   Two datasets: \n\
		Ricksep < in.H data1=comparison.H nview=2 view1_data=data1 \n\
   Velocity anlaysis: \n\
	  Ricksep < cmps.H mode=velan view1_data=vscan   \n\
       view2_data=nmoed nviews=3 nview=3 v0=1.5 dv=.025 \n\
	 4-D: \n\
		Ricksep < data.H nview=2 norder=1,3,4,5,2 norder1=1,2,3,4,5 \n\
*/

/* print text on screen */
int HelpPrint (char *start,char *finish)
	{
	char *startp=NULL, *finishp=NULL;
	extern char *help;

	startp = strstr (help,start);
	finishp = strstr (help,finish);
	if (startp == NULL || finishp == NULL) return(0);
	for (;startp<finishp; startp++) fputc (*startp,stderr);
	fputc ('\n',stderr);
	fflush (stderr);
 	return(0);
	}

/* pipe text through more */
HelpMore (char *start,char *finish)
	{
	FILE *pfile, *popen();
	char *startp=NULL, *finishp=NULL;
	extern char *help;

	startp = strstr (help,start);
	finishp = strstr (help,finish);
	if (startp == 0 || finishp == 0) return(0);
	pfile = popen ("more","w");
	for (;startp<finishp; startp++) fputc (*startp,pfile);
	fputc ('\n',pfile);
	fflush (pfile);
	pclose (pfile);
  return(0);
	}
#endif
