#define SET_SDOC 1
#include<superset.h>
#include<../include/superset_internal.h>

int sep3d_have_dff(char *tag){
sep_3d *info;
 info=tag_info_sep3d(tag, INQUIRE);
 if(info==SEPNULL) return(sepwarn(NOT_MET,
   "trouble grabbing structure for tag %s \n",tag));
if(info->dff==SEPNULL) return(0);
else return(1);
}


int sep3d_grab_nsect(char *tag,int *nsect){
sep_3d *info;
sep_dff *info_dff;
 info=tag_info_sep3d(tag, INQUIRE);
 if(info==SEPNULL) return(sepwarn(NOT_MET,
   "trouble grabbing structure for tag %s \n",tag));
 if(info->dff==SEPNULL) { *nsect=1; return(SUCCESS);}
 else return(SEPDFF_grab_nsect(info->dff,nsect));



  return(SUCCESS);
}

int sep3d_set_nsect(char *tag,int nsect){
sep_3d *info;
sep_dff *info_dff;
 info=tag_info_sep3d(tag, INQUIRE);
 if(info==SEPNULL) return(sepwarn(NOT_MET,
   "trouble grabbing structure for tag %s \n",tag));
 if(info->dff==SEPNULL)  return(SUCCESS);
 else return(SEPDFF_set_nsect(info->dff,nsect));
  return(SUCCESS);
}



int SEPDFF_grab_nsect(sep_dff *info,int *nsect){
  *nsect=info->nsect;
return(SUCCESS);
}

int SEPDFF_del_nsect(sep_dff *info){
int i;
if(info->nsect>0){
  for(i=0; i < info->nsect; i++){
    free(info->mach_sect[i]);
    free(info->tag_sect[i]);
  }
  free(info->wind_sect_nh);
  free(info->mach_sect);
  free(info->sect_thread);
  free(info->tag_sect);
  info->tag_sect=SEPNULL;
  info->mach_sect=SEPNULL;
} 
info->nsect= 0;
return(SUCCESS);
}

int SEPDFF_set_nsect(sep_dff *info,int nsect){
int i;
if(nsect<1) return(sepwarn(NOT_MET,"tag:%s  invalid sect_nect (%d) \n",info->name,nsect));
if(info->nsect>0) SEPDFF_del_nsect(info);
  
  info->nsect= nsect;
  info->mach_sect=(char**)malloc(sizeof(char*)*info->nsect);
  info->tag_sect=(char**)malloc(sizeof(char*)* info->nsect);
  info->sect_thread=(int*)malloc(sizeof(char*)* info->nsect);
  info->wind_sect_nh=(int*)malloc(sizeof(char*)* info->nsect);
    for(i=0;i < info->nsect; i++){
      info->mach_sect[i]=(char*)malloc(sizeof(char)*20);
      info->tag_sect[i]=(char*)malloc(sizeof(char)*20);
      strcpy(info->mach_sect[i],"UNDEFINED");
      strcpy(info->tag_sect[i],"UNDEFINED");
      info->sect_thread[i]=-1;
      info->wind_sect_nh[i]=0;
    }
return(SUCCESS);
}


int SEPDFF_grab_sect_threads(sep_dff *info, int *sects){
int n,i;
if(info->sect_thread==SEPNULL)
  return (sepwarn(FAIL_OTHER,"tag:%s axis convert not set\n",info->name));   /* Not a valid */
if(info->nsect ==0)
  return (sepwarn(FAIL_OTHER,"tag:%s nsect not set",info->name));   /* Not a valid */
memcpy((void*)sects,(const void*)info->sect_thread,sizeof(int)*info->nsect);
return(SUCCESS);
}

int SEPDFF_set_sect_threads(sep_dff *info, int *sects){
int n,i;
if(info->sect_thread==SEPNULL)
  return (sepwarn(FAIL_OTHER,"tag:%s axis convert not set\n",info->name));   /* Not a valid */
if(info->nsect ==0)
  return (sepwarn(FAIL_OTHER,"tag:%s nsect not set",info->name));   /* Not a valid */
memcpy((void*)info->sect_thread,(const void*)sects,sizeof(int)*info->nsect);
return(SUCCESS);
}
