#define SET_SDOC 1

#include<sitedef.h>
#include<math.h>
#include<superset.h>
#include<../include/superset_internal.h>

int partition_d(double  **A, int first, int last) ;
void quicksort_d(double  **A, int first, int last) ;
int SEP3D_convert_global_local(sep_3d *info_big, sep_3d *info_small, sep_dff *info_dff, int isect,  int ncoord, double *coord);
int SEP3D_convert_local_global(sep_3d *info_big, sep_3d *info_small, sep_dff *info_dff, int isect,  int ncoord, double *coord);

#if NeedFunctionPrototypes
_XFUNCPROTOBEGIN

int SEP3D_add_header_section(sep_3d *info_small, sep_dff *info_dff, sep_3d *info_big, int isect, int nmap,int *map)
_XFUNCPROTOEND
#endif
{
int i,i1,ic;
int n123,only_one,ig,ih;
int *nout,*fout, *jout;
double *coord_temp;

if(info_big->file_format==REGULAR) return(SUCCESS);

if(info_dff->sect_axis==1){
  if(info_big->nh>0){
    memcpy((void*) info_big->headers,(const void*)info_small->headers,
     info_big->nh*info_small->nkeys*sizeof(int));
    memcpy((void*) info_big->drn,(const void*)info_small->drn,
     info_big->nh*sizeof(int));
  }
	if(info_big->ncoord>0){
    memcpy((void*) info_big->coord,(const void*)info_small->coord,
     info_big->ncoord*sizeof(double));
  }
}
else{
  coord_temp=(double*) malloc(sizeof(double)*info_small->ncoord);
  memcpy((void*) coord_temp,(const void*)info_small->coord,
      info_small->ncoord*sizeof(double));
  if(0!=SEP3D_convert_local_global(info_big,info_small,info_dff,isect,
    info_small->ncoord, coord_temp)){
      free(coord_temp);
      return(sepwarn(NOT_MET,"trouble converting coordinates \n"));
  }
  for(i1=0,ic=0; i1 < nmap; i1++){
    if(map[i1]==isect){
      memcpy((void*)(info_big->headers+info_big->nkeys*i1),
        (const void*)(info_small->headers+info_big->nkeys*ic),
           info_big->nkeys*4);
      memcpy((void*)(info_big->coord+i1), (const void*)(coord_temp+ic),sizeof(double));
      memcpy((void*)(info_big->drn+i1), (const void*)(info_small->drn+ic),sizeof(int));
      ic++;
    }
  }
  free(coord_temp);
}
  
return(SUCCESS);
}

#if NeedFunctionPrototypes
_XFUNCPROTOBEGIN
int SEP3D_add_data_section(sep_3d *info_small,char *data_in, sep_3d *info_big, sep_dff *info_dff,char *data_out, int isect,int nmap, int *map)
_XFUNCPROTOEND
#endif
{
int i,i2,i1,ic,iloc;
int n123,only_one,ig,ih,ntot;
int nout,fout, jout,esize,nown;
double *coord_temp;
int *axis_map;


/*t1=(float*) data_in;*/
/*t2=(float*) data_out;*/


esize=SEP3D_get_esize(info_big);

/*in this case we are just going to pile on*/
if(info_dff->sect_axis==1){
  axis_map=(int*) malloc(sizeof(int)*info_big->nwind[0]);
  if(0!= SEPDFF_local_axis1_map(info_dff, isect,axis_map, &ntot))
    return(sepwarn(NOT_MET,"trouble making axis1 map \n"));

  for(i2=0; i2 < nmap; i2++){
    for(i1=0; i1 < ntot; i1++){
      memcpy((void*)(data_out+esize*(i2*info_big->nwind[0]+axis_map[i1])), (const void*)
        (data_in+esize*(i2*ntot+i1)),esize);
    }
  }
  if(info_big->file_format==REGULAR) memcpy((void*)(info_big->coord),
    (const void*)info_small->coord,nmap*sizeof(double));
  free(axis_map);
}
else{
  if(info_small->file_format==REGULAR){
    coord_temp=(double*) malloc(sizeof(double)*info_small->ncoord);
    memcpy((void*) coord_temp, (const void*)info_small->coord, sizeof(double)*info_small->ncoord);
    if(0!=SEP3D_convert_local_global(info_big,info_small,info_dff,isect,info_small->ncoord,
        coord_temp)){
        free(coord_temp);
        return(sepwarn(NOT_MET,"trouble converting coordinates \n"));
    }
  }
    for(i1=0,ic=0; i1 < nmap; i1++){
      if(map[i1]==isect){
        memcpy((void*)(data_out+esize*info_big->nwind[0]*i1),
          (const void*)(data_in+esize*info_big->nwind[0]*ic),
          info_big->nwind[0]*esize);
          
        if(info_small->file_format==REGULAR)
          memcpy((void*)(info_big->coord+i1), 
            (const void*)(coord_temp+ic),sizeof(double));
        ic++;
      }
    }
    if(info_small->file_format==REGULAR) free(coord_temp);
 }
 return(SUCCESS);
}

/*
When combining sections headers and data are not ordered according to the
grid but according to section numbers.

This function fixes that problem

*/


#if NeedFunctionPrototypes
_XFUNCPROTOBEGIN
int sep3d_sect_resync(sep_3d *info, int do_data, char *data)
_XFUNCPROTOEND
#endif
{
int *temph1,*temph2,*toi,*fromi;
char *tempd1,*tempd2,*toc,*fromc;
int *done,i,j,n123;
int *ipos,odd,nsz;
int *ilocs,esize,*shift;
int do_header,ito,ifrom;
double **list;
int **listi;
/* build a grid sect map */

  if(   info->ncoord==0) return(SUCCESS);

  if(info->dff==SEPNULL)
   return(sepwarn(NOT_MET,"tag=%s not a distributed tag \n",info->name));

  if(info->ncoord==0) return(0);

  list=(double**) malloc(sizeof(double*)*info->ncoord);
  /* make a list[ncoord][2] where 0 is the trace number, 1 is the place in array*/
  for(i=0; i < info->ncoord; i++) list[i]=(double*)malloc(sizeof(double)*2);

  for(i=0; i < info->ncoord; i++) {list[i][0]=info->coord[i]; list[i][1]=(double)i;
}
  quicksort_d(list,0,info->ncoord-1);


  listi=(int**) malloc(sizeof(int*)*info->ncoord);
  for(i=0; i < info->ncoord; i++) {
    listi[i]=(int*)malloc(sizeof(int)*2);
    listi[i][0]=i; listi[i][1]=(int)list[i][1];
  }
  for(i=0; i < info->ncoord; i++) free(list[i]); free(list);

  

done=(int*) malloc(sizeof(int)* info->ncoord);
if(info->nkeys>0) do_header=1;
else do_header=0;
esize=SEP3D_get_esize(info);
if(do_header==1) {
  temph1=(int*)malloc(sizeof(int)*info->nkeys);
  temph2=(int*)malloc(sizeof(int)*info->nkeys);
} 
if(do_data==1){
  tempd1=(char*)malloc(sizeof(char)*info->n[0]*esize);
  tempd2=(char*)malloc(sizeof(char)*info->n[0]*esize);
} 
for(i=0; i < info->ncoord; i++) done[i]=0;
for(i=0; i < info->ncoord; i++){
  if(done[i]==0 && listi[i][1]!=i){
    ito=i; ifrom=listi[i][1];
    if(do_header==1)
      memcpy((void*)temph1,
       (const void*)(info->headers+ito*info->nkeys), sizeof(int)*info->nkeys);
    if(do_data==1)
      memcpy((void*)tempd1,
     (const void*)(data+ito*esize*info->n[0]), esize*info->n[0]);
    fromi=temph1; toi=temph2;
    fromc=tempd1; toc=tempd2;
    odd=1;
    
    while(ito!=ifrom && done[ito]!=1){
      if(do_header==1){
        memcpy((void*)toi,
        (const void*)(info->headers+ito*info->nkeys), sizeof(int)*info->nkeys);
        memcpy((void*)(info->headers+ito*info->nkeys),(const void*)fromi,
            sizeof(int)*info->nkeys);
      }
      if(do_data==1){
        memcpy((void*)toc,
         (const void*)(data+ito*esize*info->n[0]), esize*info->n[0]);
        memcpy((void*)(data+ito*esize*info->n[0]),(const void*) fromc,esize*info->n[0]);
      }
      if(odd==1){ fromi=temph2; toi=temph1; fromc=tempd2; toc=tempd1; odd=0;}
      else{       fromi=temph1; toi=temph2; fromc=tempd1; toc=tempd2; odd=1;}
      ifrom=ito; done[ito]=1;
      ito=listi[ito][1]; 
   }
 }
 else done[i]=1;
}
if(do_header==1) { free(temph1); free(temph2);}
if(do_data  ==1) { free(tempd1); free(tempd2);}
for(i=0; i < info->ncoord; i++) free(listi[i]); free(listi);
free(done);
return(SUCCESS);
}

#if NeedFunctionPrototypes
_XFUNCPROTOBEGIN
int SEP3D_create_index_maps(sep_3d *info_big, sep_dff *info_dff, sep_3d *info_small,
  int *nsize, int *index_big, int *index_small)
_XFUNCPROTOEND
#endif
{
int *i_map;
int *i_pass;
double  *d_pass,**list;
int impi,ntot,i;

/*first do the local*/
if(0!=SEP3D_find_sect_index(info_small,info_small,info_dff,index_small))
  return(sepwarn(NOT_MET,"trouble finding local sect indicies thread=%d \n",info_dff->impi));

for(impi=0,ntot=0; impi < info_dff->nmpi; impi++){
   if(info_dff->impi==0 && impi==0){
     memcpy((void*)info_big->coord,(const void*)info_small->coord,
      sizeof(double)*info_small->ncoord);
     memcpy((void*)index_big,(const void*)index_small, sizeof(int)*info_small->ncoord);
   }
   else if(info_dff->impi==0 || info_dff->impi == impi){
     if(info_dff->impi==0) d_pass=(info_big->coord+ntot);
     else d_pass=info_small->coord;
     if(info_dff->impi==0) i_pass=(index_big+ntot);
     else i_pass=index_small;
     if(0!=sep3d_pass_data(info_dff->impi,impi,0,(int)sizeof(int), 
        nsize[impi], (char*)i_pass))
       return(sepwarn(NOT_MET,"trouble passing data from=%d to=%d \n",impi,0));
     if(0!=sep3d_pass_data(info_dff->impi,impi,0,(int)sizeof(double), 
        nsize[impi], (char*)d_pass))
       return(sepwarn(NOT_MET,"trouble passing data from=%d to=%d \n",impi,0));
   }
/*   if(info_dff->impi==0){*/
/*     for(i=0; i< nsize[impi]; i++) index_big[i+ntot]=impi;*/
/*   }*/
   ntot+=nsize[impi];
}
if(info_dff->impi==0){


       /*
          [0] = coord_global
          [1] = section_num
       */
  list=(double**)malloc(sizeof(double*)*info_big->ncoord);
  for(i=0; i < info_big->ncoord; i++){
     list[i]=(double*)malloc(sizeof(double)*2);
     list[i][0]=info_big->coord[i];
     list[i][1]=index_big[i];
  }
  quicksort_d(list,0,info_big->ncoord-1);
  for(i=0; i < info_big->ncoord; i++){
    index_big[i]=list[i][1]; 
    free(list[i]);
  }
  free(list);
  
}
return(SUCCESS);
}




                                                                                
#if NeedFunctionPrototypes
_XFUNCPROTOBEGIN
int SEP3D_grab_header_section(sep_3d *info_big,sep_dff *info_dff, sep_3d *info_small, int isect,int nmap, int *map)
_XFUNCPROTOEND
#endif
{
int i,n123,nh,ng,nh2;
int ic,i1;

if(info_big->file_format==REGULAR) return(SUCCESS);
if(info_dff->sect_axis==1){
  memcpy((void*)(info_small->headers),
     (const void*)(info_big->headers),sizeof(int)*info_big->nkeys*info_big->nh);
  memcpy((void*)(info_small->drn), (const void*)(info_big->drn),info_big->nh*sizeof(int));
  memcpy((void*)(info_small->coord), 
      (const void*)(info_big->coord),info_big->nh*sizeof(double));
}
else{
  for(i1=0,ic=0; i1 < nmap; i1++){
    if(map[i1]==isect){
      memcpy((void*)(info_small->headers+info_big->nkeys*ic),
        (const void*)(info_big->headers+info_big->nkeys*i1),
         info_big->nkeys*sizeof(int));
      memcpy((void*)(info_small->drn+ic),
        (const void*)(info_big->drn+i1), sizeof(int));
      memcpy((void*)(info_small->coord+ic),
        (const void*)(info_big->coord+i1),sizeof(double));
      ic++;
    }
  }
  if(0!=SEP3D_convert_global_local(info_big,info_small,info_dff,isect,info_small->ncoord,
      info_small->coord)){
      return(sepwarn(NOT_MET,"trouble converting coordinates \n"));
  }
}
return(SUCCESS);
}
#if NeedFunctionPrototypes
_XFUNCPROTOBEGIN
int SEP3D_grab_data_section(sep_3d *info_big, sep_dff *info_dff, sep_3d *info_small, int isect,char *data_in, char *data_out, int nmap, int *map)
_XFUNCPROTOEND
#endif
{
int i,i2,i1,esize;
int n123,only_one,ig,ih,ng,nh2,ic;
int nout,fout,jout;
double *coord_temp;
int nc,*axis_map,ntot;

esize=SEP3D_get_esize(info_big);



if(info_dff->sect_axis==1){
  axis_map=(int*) malloc(sizeof(int)*info_big->nwind[0]);
  if(0!= SEPDFF_local_axis1_map(info_dff, isect,axis_map, &ntot))
    return(sepwarn(NOT_MET,"trouble making axis1 map \n"));

  for(i2=0; i2 < nmap; i2++){
    for(i1=0; i1 < ntot; i1++){
      memcpy(
       (void*) (data_out+esize*(i2*ntot+i1)),
       (const void*)(data_in+esize*(i2*info_big->nwind[0]+axis_map[i1])), 
        esize);
    }
  }
  if(info_big->file_format==REGULAR) {
     memcpy((void*)info_small->coord,
      (const void*)info_big->coord,sizeof(double)*nmap);
  } 
}
else{
  for(i1=0,ic=0; i1 < nmap; i1++){
    if(map[i1]==isect){
      memcpy((void*)(data_out+esize*info_big->nwind[0]*ic),
        (const void*)(data_in+esize*info_big->nwind[0]*i1),info_big->nwind[0]*esize);
      if(info_small->file_format==REGULAR){
        memcpy((void*)(info_small->coord+ic), (const void*)(info_big->coord+i1),sizeof(double));
      }
      ic++;
    }
  }
  if(info_small->file_format==REGULAR){
    if(0!=SEP3D_convert_global_local(info_big,info_small,info_dff,isect,info_small->ncoord,
        info_small->coord)){
        return(sepwarn(NOT_MET,"trouble converting coordinates \n"));
    }
  }
}
return(SUCCESS);
}
_XFUNCPROTOBEGIN
int SEP3D_convert_global_local(sep_3d *info_big, sep_3d *info_small,sep_dff *info_dff, int isect,  int ncoord, double *coord)
_XFUNCPROTOEND
{
int i,idim,nt,inew;
double *blocks,*blockb;
int loc;
int f,j,nremain,n,iax;
int **list;
int ibeg;
double dnew;

if(info_dff==SEPNULL) return(sepwarn(NOT_MET,"can't convert a non sectioned tag %s \n",info_big->name));

if(info_dff->master_data==1) ibeg=0;
else ibeg=1;
if(info_dff->pattern==NODEF)
  return(sepwarn(NOT_MET,"pattern undefined for tag %s can't section \n",
  info_big->name));

iax=info_dff->sect_axis-1;
if(info_dff->master_data==1) ibeg=0;
else ibeg=1;

if(info_dff->pattern==BLOCK){
  j=1; nt=0;nremain=info_big->n[iax];
  for(i=ibeg,f=0; i <= isect; i++){
    nt=ceil((double)nremain/((double)(info_dff->nsect-i)));
    nremain-=nt; 
    f+=nt;
  }
  n=nt;
  f-=nt;
}
else if(info_dff->pattern==SPREAD){
   j=info_dff->nsect-ibeg;
   f=isect-ibeg;
   n=info_big->n[iax]/(info_dff->nsect-ibeg);
   nremain=info_big->n[iax] - n*(info_dff->nsect-ibeg) ;
   if(nremain!=0){
     if(isect-ibeg < nremain) n+=1;
   }
}
blocks=(double*) malloc(sizeof(double)*(info_small->ndims-1));
blockb=(double*) malloc(sizeof(double)*(info_big->ndims-1));
for(i=1,blocks[0]=1; i < info_small->ndims-1;i++){
   if(iax==i) blocks[i]=blocks[i-1]*n;
   else blocks[i]=blocks[i-1]*info_small->n[i];
}
for(i=1,blockb[0]=1; i < info_big->ndims-1;i++) blockb[i]=blockb[i-1]*info_big->n[i];

for(i=0,inew; i < ncoord; i++){
  for(dnew=0,idim=1; idim < info_big->ndims; idim++){
/*     if(idim==iax) loc=(int)(((coord[i]/blockb[idim-1])-f)/j)%n;*/
     if(idim==iax) loc=(((int)(coord[i]/blockb[idim-1]))%info_big->n[idim]-f)/j;
     else loc=(((int)(coord[i]/blockb[idim-1]))%info_big->n[idim]);
     dnew+=loc*blocks[idim-1];
  }
  coord[i]=dnew;
}
free(blocks);
free(blockb);
return(SUCCESS);
}
_XFUNCPROTOBEGIN
int SEP3D_convert_local_global(sep_3d *info_big, sep_3d *info_small, sep_dff *info_dff, int isect,  int ncoord, double *coord)
_XFUNCPROTOEND
{
int i,idim,nt,inew;
int loc,ibeg;
int f,j,nremain,n,iax;
double *sblock,*blockb;
double dnew;
if(info_dff==SEPNULL) return(sepwarn(NOT_MET,"can't convert a non sectioned tag %s \n",info_big->name));

if(ncoord==0) return(0);
if(info_dff->pattern==NODEF)
  return(sepwarn(NOT_MET,"pattern undefined for tag %s can't section \n",
  info_big->name));


if(info_dff->master_data==1) ibeg=0;
else ibeg=1;

iax=info_dff->sect_axis-1;

if(info_dff->pattern==BLOCK){
  j=1; nt=0;nremain=info_big->n[iax];
  for(f=0,i=ibeg; i <=isect; i++){
    nt=ceil((double)nremain/((double)(info_dff->nsect-i)));
    nremain-=nt; 
    f+=nt;
  }
    f-=nt;
  n=nt;
}
else if(info_dff->pattern==SPREAD){
   j=(info_dff->nsect-ibeg);
   f=isect-ibeg;
   n=info_big->n[iax]/(info_dff->nsect-ibeg);
   nremain=info_big->n[iax] - n*(info_dff->nsect-ibeg) ;
   if(nremain!=0){
     if(isect-ibeg < nremain) n+=1;
   }
}

blockb=(double*) malloc(sizeof(double)*(info_big->ndims-1));
sblock=(double*) malloc(sizeof(double)*(info_small->ndims-1));
i=1; 
for(i=1,blockb[0]=1; i < info_big->ndims-1;i++){ 
   blockb[i]=blockb[i-1]*info_big->n[i];
}
for(i=1, sblock[0]=1; i < info_small->ndims-1; i++){
   if(iax==i) sblock[i]=sblock[i-1]*n;
   else sblock[i]=sblock[i-1]*info_small->n[i];
}

for(i=0; i < ncoord; i++){
  for(dnew=0,idim=1; idim < info_big->ndims; idim++){
     if(idim==iax) loc=((int)(coord[i]/sblock[idim-1]))%n*j+f;
     else loc=((int)(coord[i]/sblock[idim-1]))%info_small->n[idim];
     dnew+=loc*blockb[idim-1];
  }
  coord[i]=dnew;
}
free(sblock);
free(blockb);
return(SUCCESS);
}

/*from
                                                                                                                     
http://ironbark.bendigo.latrobe.edu.au/courses/bcomp/c103/sem296/lectures/Lecture2.html
*/
                                                                                                                     
void quicksort_d(double  **A, int first, int last) {
    int pivindx; /* index of the element separating the two sub-arrays*/
    if (last > first) {  /* More than one element to be sorted?*/
        pivindx = partition_d(A, first, last);
        quicksort_d(A, first, pivindx - 1);
        quicksort_d(A, pivindx + 1, last);
    }
}
                                                                                                                     
int partition_d(double  **A, int first, int last) {
    int pivindx, top, i;
    double pivot[2];
                                                                                                                     
    /* Choose a pivot: select a random index between first and last.*/
    i = rand() % (last - first + 1) + first;


                                                                                                                     
    /* Put the pivot first, remember pivot, initialise ready for loop.*/
    pivot[0] = A[i][0]; pivot[1] = A[i][1];
    A[i][0] = A[first][0]; A[i][1] = A[first][1];
    A[first][0] = pivot[0];A[first][1] = pivot[1]; /* pivot now first */
                                                                                                                     
    pivindx = first;
    top = last;
    while (top > pivindx) {         /* Still unknown elements */
        /* top indicates the highest unknown element */
        if (A[top][0] >= pivot[0]) {
            top--;              /* where it belongs, count as >=*/
        } else {
            A[pivindx][0] = A[top][0];      /* shift down */
            A[pivindx][1] = A[top][1];      /* shift down */
            A[top][0] = A[pivindx + 1][0];/*shift displaced element up*/
            A[top][1] = A[pivindx + 1][1];/*shift displaced element up*/
            A[pivindx + 1][0] = pivot[0];   /* Put pivot back */
            A[pivindx + 1][1] = pivot[1];   /* Put pivot back */
            pivindx++;            /* Alter record of pivot location*/
        }
    }
    return pivindx;
}
int SEPDFF_local_axis1_map(sep_dff *info, int isect,int *axis_map, int *ntot){
int i,nlocal,ihave;

  for(i=0,ihave=0,nlocal=0; i < info->naxis_convert; i++){
    if(info->sect_thread[info->axis_convert[i]]==info->impi) {
      if(info->axis_convert[i]==isect) { 
        axis_map[ihave]=nlocal;ihave++;
      }
      nlocal++; 
    }
  }
*ntot=ihave;
  return(SUCCESS);
}
