#define SET_SDOC 1
#include<sitedef.h>
#include<../include/superset_internal.h>
#include<superset.h>

int SEPDFF_set_mach_sect(sep_dff *info,int itag, char *mach){
if(info->nsect < 1)
  return (sepwarn(FAIL_OTHER,"tag:%s nsect not set \n",info->name));   /* Not a valid */
if(info->nsect < itag)
  return (sepwarn(FAIL_OTHER,"tag:%s spread over %d requested tag %d \n",info->name,
    info->nsect,itag));   /* Not a valid */
  free(info->mach_sect[itag]);
  info->mach_sect[itag]=(char*)malloc(sizeof(char)*(int)(strlen(mach)+1));
  strcpy(info->mach_sect[itag], mach);
return(SUCCESS);
}

int SEPDFF_grab_mach_sect(sep_dff *info,int itag, char *mach){

if(info->nsect < 1)
  return (sepwarn(FAIL_OTHER,"tag:%s nsect not set \n",info->name));   /* Not a valid */
if(info->nsect < itag)
  return (sepwarn(FAIL_OTHER,"tag:%s spread over %d requested tag %d \n",info->name,
    info->nsect,itag));   /* Not a valid */
  strcpy(mach,info->mach_sect[itag]); /* assumption that it is already allocated!!!*/
return(SUCCESS);
}

int SEPDFF_set_tag_sect(sep_dff *info,int itag, char *tag){
if(info->nsect < 1)
  return (sepwarn(FAIL_OTHER,"tag:%s nsect not set \n",info->name));   /* Not a valid */
if(info->nsect < itag)
  return (sepwarn(FAIL_OTHER,"tag:%s spread over %d requested tag %d \n",info->name,
    info->nsect,itag));   /* Not a valid */
  free(info->tag_sect[itag]);
  info->tag_sect[itag]=(char*)malloc(sizeof(char)*(int)(strlen(tag)+1));
  strcpy(info->tag_sect[itag], tag);
return(SUCCESS);
}

int SEPDFF_grab_tag_sect(sep_dff *info,int itag, char *tag){

if(info->nsect < 1)
  return (sepwarn(FAIL_OTHER,"tag:%s nsect not set \n",info->name));   /* Not a valid */
if(info->nsect < itag)
  return (sepwarn(FAIL_OTHER,"tag:%s spread over %d requested tag %d \n",info->name,
    info->nsect,itag));   /* Not a valid */
  strcpy(tag,info->tag_sect[itag]); /* assumption that it is already allocated!!!*/
return(SUCCESS);
}

