#define SET_SDOC 1
#include<../include/superset_internal.h>
#include<sitedef.h>
#include<superset.h>
#include<math.h>

int SEPDFF_grab_sect_ithread(sep_dff *info,int isect, int *sect){
if(info->nsect_ithread < 1)
  return (sepwarn(FAIL_OTHER,"tag:%s nsect_ithread has not set \n",info->name));   /* Not a valid */
if(info->nsect_ithread < isect)
  return (sepwarn(FAIL_OTHER,"tag:%s thread holds  %d  sections requested section %d \n",info->name,
    info->nsect_ithread,isect));   /* Not a valid */
  *sect=info->sect_ithread[isect];
return(SUCCESS);
}

int sep3d_grab_sectaxis(char *tag ,int *axis){
sep_3d *info;
info = tag_info_sep3d(tag, INQUIRE);
if(info==SEPNULL)
 return(sepwarn(NOT_MET,"Not a valid tag %s \n",tag));
*axis=-1;
if(info->dff==SEPNULL) return(0);
return(SEPDFF_grab_sect_axis(info->dff,axis));
}

int SEPDFF_grab_sect_axis(sep_dff *info,int *axis){
  *axis=info->sect_axis;
return(SUCCESS);
}

int SEPDFF_set_sect_axis(sep_dff *info,int axis, int nlen){
if(0!=SEPDFF_del_axis_convert(info))
  return (sepwarn(INVALID_STRUC,"tag:%s trouble setting sect_axis \n",info->name));   /* Not a valid */
  info->sect_axis=axis;
 info->naxis_convert=nlen;
info->axis_convert=(int*)malloc(sizeof(int)*nlen);
return(SUCCESS);
}




int sep3d_grab_nsect_ithread(sep_dff *info,int *nsect){
  *nsect=info->nsect_ithread;
return(SUCCESS);
}
                                                     
int SEPDFF_set_axis_thread_info(sep_dff *info){
int i,j,n;
if(info->impi <0 )
  return (sepwarn(NOT_MET,"tag:%s  impi hasn't been set\n",info->name));   /* Not a valid */
if(info->sect_thread ==SEPNULL )
  return (sepwarn(NOT_MET,"tag:%s  sect_thread hasn't been set\n",info->name));   /* Not a valid */

SEPDFF_del_axis_thread_info(info);

/*find number of sections this thread has */
info->nsect_ithread=0;
for(i=0; i < info->nsect; i++)
  if(info->sect_thread[i]==info->impi) info->nsect_ithread++; 
info->sect_ithread=(int*)malloc(sizeof(int)*info->nsect_ithread);
info->nsect_ithread=0;
for(i=0; i < info->nsect; i++){
  if(info->sect_thread[i]==info->impi) {
    info->sect_ithread[info->nsect_ithread]=i; 
    info->nsect_ithread++; 
  }
}
return(SUCCESS);
}
int SEPDFF_grab_axis_convert(sep_dff *info,int *axis_convert){

  memcpy((void*)axis_convert,(const void*)info->axis_convert,(int)sizeof(int)*info->naxis_convert);

  return(SUCCESS);
}
int SEPDFF_del_axis_convert(sep_dff *info){

  if(info->axis_convert!=SEPNULL){
    free(info->axis_convert); info->axis_convert=SEPNULL;  info->naxis_convert=0;
  }

  return(SUCCESS);
}

int SEPDFF_set_axis_convert(sep_dff *info,int *axis_info){
  memcpy( (void*)info->axis_convert, (const void*)axis_info, (int)sizeof(int)*info->naxis_convert);
  return(SUCCESS);
}

int SEPDFF_pattern_to_axis_convert(sep_dff *info)
{
int i,ndone,nremain,isect,ndo,ifirst;
  
  if(info->naxis_convert==0)
    return(sepwarn(NOT_MET,"axis has not been set for tag=%s \n",info->name));

  if(info->nsect<=1)
    return(sepwarn(NOT_MET,"2:nsect has not been set for tag=%s \n",info->name));


  if(info->master_data==1) ifirst=0;
  else ifirst=1;
  if(info->pattern==BLOCK){
    nremain=info->naxis_convert; ndone=0;
    for(isect=ifirst; isect < info->nsect;isect++){
      ndo=ceil((double)nremain/((double)(info->nsect-isect)));
      for(i=0; i < ndo; i++){
        info->axis_convert[i+ndone]=isect;
      }
      nremain-=ndo; ndone+=ndo;
    }
  }
  else if(info->pattern==SPREAD){
    isect=ifirst;
    for(i=0; i < info->naxis_convert; i++){
      info->axis_convert[i]=isect;
      isect++; if(isect==info->nsect) isect=ifirst;
    }
  }
  else return(sepwarn(NOT_MET,"Pattern not set for tag=%s \n",info->name));


  return(SUCCESS);
}



int SEPDFF_del_axis_thread_info(sep_dff *info){
  int i;
  if(info->nsect_ithread>0){
    free(info->sect_ithread); info->sect_ithread=SEPNULL;
    info->nsect_ithread=0;
  }
  return(SUCCESS);
}
