/*
*
*
*This routine will plot the tics for the axes.  
*
*
*/
#include "glplot.h"
#ifdef USE_PROTO
int gl_plottic ( struct coordinfo *coord,struct axisinfo * axis, int counter)
#else
int gl_plottic (coord, axis, counter)
    struct coordinfo *coord;
    struct axisinfo *axis;
    int             counter;
#endif
{
float           xc, yc, position1, position2, position3, position4, xmax, min1, min2, max1, max2, num, tic, num0, dtic, axisor, dnum, vs;
int             length, i, temp2;
float           temp1, ch;
char            string[10];

    ch = (axis->labelsz / 33.);
    vs = ch * 5. / 10.;
    num0 = axis->num0;
    dnum = axis->dnum;
    vp_fat (axis->fat[counter]);
    if (*axis->wherelabel == 'l' || *axis->wherelabel == 'r')
    {
	min1 = coord->min2;
	max1 = coord->max2;
	min2 = coord->min1;
	max2 = coord->max1;
	xmax = coord->max1;
    }
    if (*axis->wherelabel == 't' || *axis->wherelabel == 'b')
    {
	min1 = coord->min1;
	max1 = coord->max1;
	min2 = coord->min2;
	max2 = coord->max2;
	xmax = coord->max1;
    }

    if (max1 < min1)
    {
	temp1 = min1;
	min1 = max1;
	max1 = temp1;
    } 
    if (num0 >= max1)
	num0 = min1 + (max1 - min1) / 2.; 

    if ((coord->xreverse) && (*axis->wherelabel == 't' || *axis->wherelabel == 'b'))
    {
	temp1 = min1;
	min1 = max1;
	max1 = temp1;
	dnum = dnum;
        num0 = min1 + max1 - num0;

    }
    if ((coord->yreverse) && (*axis->wherelabel == 'l' || *axis->wherelabel == 'r'))
    {
        num0 = min1 + max1 - num0;
	temp1 = min1;
	min1 = max1;
	max1 = temp1;
	dnum = dnum;
    }
    if ((coord->yreverse) && (*axis->wherelabel == 'l' || *axis->wherelabel == 'r'))
    {
	for (num = num0; num >= max1; num -= dnum)
	    gl_maketic (num, coord, axis);
    }
    else
    if ((coord->xreverse) && (*axis->wherelabel == 't' || *axis->wherelabel == 'b'))
    {
	for (num = num0; num >= max1; num -= dnum)
	    gl_maketic (num, coord, axis);
    }
    else
    {
	for (num = num0; num <= max1; num += dnum)
	    gl_maketic (num, coord, axis);
    }
	return 0;
}


/**
*
*This routine will plot the tics for the axes.  
*
*
*/
gl_maketic (num, coord, axis)
    float           num;
    struct axisinfo *axis;
    struct coordinfo *coord;
{
float           xc, yc, position1, position2, position3, position4, xmax, min1, max1, min2, max2, tic, num0, dtic, axisor, dnum, vs;
int             length, i;
float           temp1, ch;
char            string[10];

    ch = (axis->labelsz / 33.);
    vs = ch * 5. / 10.;
    num0 = axis->num0;
    dnum = axis->dnum;
    if (*axis->wherelabel == 'l' || *axis->wherelabel == 'r')
    {
	min1 = coord->min2;
	min2 = coord->min1;
	max1 = coord->max2;
	max2 = coord->max1;
	xmax = coord->max1;
    }
    if (*axis->wherelabel == 't' || *axis->wherelabel == 'b')
    {
	min1 = coord->min1;
	min2 = coord->min2;
	max1 = coord->max1;
	max2 = coord->max2;
	xmax = coord->max1;
    }
    if (fabs (num) < ((max1 - min1) / 10000))
    {
	num = 0.0;
    }
    if (*axis->wheretics != 'a')
    {
	switch (*axis->wherelabel)
	{
	case 't':
	    position1 = num;
	    position2 = max2;
	    break;
	case 'b':
	    position1 = num;
	    position2 = min2;
	    break;
	case 'r':
	    position1 = max2;
	    position2 = num;
	    break;
	case 'l':
	    position1 = min2;
	    position2 = num;
	    break;
	}
	gl_umove (position1, position2);
	gl_where (&xc, &yc);
	switch (*axis->wherelabel)
	{
	case 'b':
	    position3 = xc;
	    position4 = yc - vs;
	    break;
	case 't':
	    position3 = xc;
	    position4 = yc + vs;
	    break;
	case 'l':
	    position3 = xc - vs;
	    position4 = yc;
	    break;
	case 'r':
	    position3 = xc + vs;
	    position4 = yc;
	    break;
	}
	gl_draw (position3, position4);
    }
    else
    {
	switch (*axis->wherelabel)
	{
	case 'b':
	    position1 = num;
	    position2 = axis->axisor;
	    break;
	case 't':
	    position1 = num;
	    position2 = axis->axisor;
	    break;
	case 'l':
	    position1 = axis->axisor;
	    position2 = num;
	    break;
	case 'r':
	    position1 = axis->axisor;
	    position2 = num;
	    break;
	}
	gl_umove (position1, position2);
	gl_where (&xc, &yc);
	switch (*axis->wherelabel)
	{
	case 'b':
	    position3 = xc;
	    position4 = yc - vs;
	    break;
	case 't':
	    position3 = xc;
	    position4 = yc + vs;
	    break;
	case 'l':
	    position3 = xc - vs;
	    position4 = yc;
	    break;
	case 'r':
	    position3 = xc + vs;
	    position4 = yc;
	    break;
	}
	gl_draw (position3, position4);
    }
    if (axis->dtic != dnum)
    {
	for (tic = axis->num0; tic <= max1; tic += axis->dtic)
	{
	    switch (*axis->wherelabel)
	    {
	    case 'b':
		position1 = tic;
		position2 = min2;
		break;
	    case 't':
		position1 = tic;
		position2 = max2;
		break;
	    case 'l':
		position1 = min2;
		position2 = tic;
		break;
	    case 'r':
		position1 = max2;
		position2 = tic;
		break;
	    }
	    gl_umove (position1, position2);
	    gl_where (&xc, &yc);
	    if (axis->axisor == min2)
	    {
		switch (*axis->wherelabel)
		{
		case 'b':
		    position3 = xc;
		    position4 = yc - vs / 2.;
		    break;
		case 't':
		    position3 = xc;
		    position4 = yc + vs / 2.;
		    break;
		case 'l':
		    position3 = xc - vs / 2.;
		    position4 = yc;
		    break;
		case 'r':
		    position3 = xc - vs / 2.;
		    position4 = yc;
		    break;
		}
	    }
	    else
	    {
		switch (*axis->wherelabel)
		{
		case 'b':
		    position3 = xc;
		    position4 = yc - vs / 4.;
		    break;
		case 't':
		    position3 = xc;
		    position4 = yc + vs / 4.;
		    break;
		case 'l':
		    position3 = xc - vs / 4.;
		    position4 = yc;
		    break;
		case 'r':
		    position3 = xc - vs / 4.;
		    position4 = yc;
		    break;
		}

	    }
	    gl_draw (position3, position4);
	}
    }
}
