#include <glplot.h>
#ifdef USE_PROTO
int gl_stdplot (struct datainfo *data, struct coordinfo *coordinate,
	    struct axisinfo * axis1, struct axisinfo *axis2, 
	    struct gridinfo *grid, struct titleinfo *title,
 	    int counter, int fastplt, int wantframe, int wantframenum)
#else
int gl_stdplot (data, coordinate, axis1, axis2, grid, title, counter, fastplt, wantframe, wantframenum)
    struct datainfo *data;
    struct coordinfo *coordinate;
    struct axisinfo *axis1;
    struct axisinfo *axis2;
    struct gridinfo *grid;
    struct titleinfo *title;
    int             counter, fastplt;
    int             wantframe, wantframenum;
#endif
{

    /*
     * declaration of internal variables for Graph 
     */

    if (fastplt < 20)
    {

	/* initialization for plotting axes */

	gl_clip (-VP_MAX, -VP_MAX, VP_MAX, VP_MAX);
	gl_color (axis1->col[counter]);
	gl_fat (axis1->fat[counter]);

	/* If a frame is wanted draw it */
	if (wantframe)
	    if (fastplt < 16)
	    {
		gl_plotframe (coordinate, axis1->col[counter]);
	    }
	if (fastplt < 14)
	{

	    /* If  y axis is wanted draw it */

	    if (((wantframe == 0) || (axis1->axisor != coordinate->min1)) && (axis1->wantaxis))
		gl_plotaxis (axis1, coordinate, counter);
	    if ((axis2->wantaxis) && fastplt < 12 )
	    {
             if (axis2->dnum != 0.)
		{
                    if (axis2->ntic != 0)
		         gl_plottic (coordinate, axis2, counter);
		    gl_labeltic (coordinate, axis2);
                 }
		/* Label y axis */
		gl_labelaxis (coordinate, axis2);
	    }
	    /* If only x axis is wanted draw it */
	    if (((wantframe == 0) || (axis2->axisor != coordinate->min2)) && (axis2->wantaxis))
		gl_plotaxis (axis2, coordinate, counter);
	    if ((axis1->wantaxis) && (fastplt < 12))
	    {
                if ((axis1->dnum != 0.))
                {
		if (axis1->ntic != 0)
		    gl_plottic (coordinate, axis1, counter);
		gl_labeltic (coordinate, axis1);
		}
                /* Label x axis */
		gl_labelaxis (coordinate, axis1 );

	    }
	    if (fastplt < 8)
	    {
		if (grid->grid1)
		{
		    gl_plotgrid (coordinate, axis1, grid, counter);
		}
		if (grid->grid2)
		{
		    gl_plotgrid (coordinate, axis2, grid, counter);
		}
	    }

	}			/* end of fastplot 14 */
	/* label title */
	    if ( title->wanttitle  && (fastplt < 3))
        {
	if (*title->wheretitle == 't' || *title->wheretitle == 'b')
	    gl_plottitle (coordinate, title, axis1, counter);
	if (*title->wheretitle == 'l' || *title->wheretitle == 'r')
	    gl_plottitle (coordinate, title, axis2, counter);
        }
	/* label movie frame if needed */
	if (wantframenum > 0 && data->n3 > 1 && fastplt < 13)
	{
	    gl_framenum (counter, data->d3, data->o3, coordinate->min1, coordinate->min2, axis1->labelsz);

	}
    }				/* end of fastplot 20 */
	return 0;
}
