/*$
=head1 NAME

cmult - complex multiplication

=head1 SYNOPSIS

C<val=complex cmult(a, b)>

=head1 INPUT PARAMETERS

=over 4

=item a,b - complex 

      numbers to multiply

=back

=head1 RETURN VALUES

=over 4

=item val -complex  

      result of multiplication

=back

=head1  DESCRIPTION

 Cmult returns a*b.

=head1 SEE ALSO

L<cdiv>

=head1 LIBRARY

B<sepmath>

=cut



>*/
#include <sepmath.h>
#if NeedFunctionPrototypes
_XFUNCPROTOBEGIN
complex cmult(complex x, complex  y)
_XFUNCPROTOEND
#else
complex cmult(x, y)
complex x,y;
#endif

	{
	complex i;
	i.re = x.re * y.re - x.im * y.im;
	i.im = x.re * y.im + x.im * y.re;
	return (i);
	}
