/*
 * Copyright 1987 the Board of Trustees of the Leland Stanford Junior
 * University. Official permission to use this software is included in
 * the documentation. It authorizes you to use this file for any
 * non-commercial purpose, provided that this copyright notice is not
 * removed and that any modifications made to this file are commented
 * and dated in the style of my example below.
 */

/*
 *
 *  source file:   ./lvplot/vp_raster.c
 *
 * Joe Dellinger (SEP), June 11 1987
 *	Inserted this sample edit history entry.
 *	Please log any further modifications made to this file:
 * Joe Dellinger Jan 14 1988
 *	Do rounding.
 * Joe Dellinger Jan 14 1990
 *	Can't change passed argument "orient" willy-nilly because
 *	when it comes from FORTRAN it's passed by pointer. Use
 *	"OFFSET" in code instead of "offset".
 */

/* This program cannot be indented! */

#include <stdio.h>
#include <vplot.h>
#include "round.h"
#include "vp_pc.h"

#ifdef FORTRAN

#define RASTER		vprastershort_
#define XLL		*xll
#define YLL		*yll
#define XPIX		*xpix
#define YPIX		*ypix
#define PPI		*ppi
#define	BIT		*bit
#define OFFSET		*offset
#define	BLAST		*blast
#define	ORIENT		*orient
#define	INVERT		*invert

#else

#define RASTER		vp_rastershort
#define XLL		xll
#define YLL		yll
#define XPIX		xpix
#define YPIX		ypix
#define PPI		ppi
#define	BIT		bit
#define OFFSET		offset
#define	BLAST		blast
#define	ORIENT		orient
#define	INVERT		invert

#endif

#define ARRAY(A,B)	array[(((INVERT)==0)?(A):(YPIX-1-(A)))*(XPIX)+(B)]

#define MAXREP	8
#define PUTHSIZE sizeof(int)

#define RASOUT(NUMPAT,NUMBYTE,BITFLAG,BYTES)	\
{\
\
    puth ((int) (NUMPAT), vp_pc._pltout);\
    puth ((int) (NUMBYTE), vp_pc._pltout);\
	for (nn = 0; nn < (NUMBYTE); nn++)\
	{\
     j=*(BYTES+nn);\
     k=j/256; j=j-k*256;\
	    putc ((char) k, vp_pc._pltout);\
	    putc ((char) j, vp_pc._pltout);\
	}\
}

/*      putc ((char) * ((BYTES) + nn), vp_pc._pltout);\*/

/*	    putc ((char) j, vp_pc._pltout);\*/
int RASTER (unsigned short *array, int BLAST, int BIT, int OFFSET, int XPIX, int YPIX, float XLL, float YLL,float  PPI,float *xur,float *yur, int ORIENT, int INVERT)
{
    int     mm, nn, nnn, ll, kk, jj, ii, count, ucount, bitbyte;
    int     ix, iy,j,k;
    unsigned char   obyte;
    int	    orient_copy;
    

	bitbyte = 1;
	putc (VP_SHORT_RASTER, vp_pc._pltout);

  

/*
 * Necessary for FORTRAN version of the routine to work reliably.
 */
    orient_copy = ORIENT;

    if (orient_copy >= 0)
	orient_copy = orient_copy % 4;
    else
	orient_copy = ((orient_copy % 4) + 4) % 4;

    puth ((int) orient_copy, vp_pc._pltout);
    puth ((int) OFFSET, vp_pc._pltout);
    ix = ROUND (XLL * RPERIN);
    iy = ROUND (YLL * RPERIN);
    puth (ix, vp_pc._pltout);
    puth (iy, vp_pc._pltout);
    if (PPI > 0)
    {
	ix += ROUND (RPERIN * XPIX / PPI);
	iy += ROUND (RPERIN * YPIX / PPI);
	*xur = ix / (float) RPERIN;
	*yur = iy / (float) RPERIN;
    }
    else
    {
	ix = ROUND (*xur * RPERIN);
	iy = ROUND (*yur * RPERIN);
    }
    puth (ix, vp_pc._pltout);
    puth (iy, vp_pc._pltout);

    puth ((int) XPIX, vp_pc._pltout);
    puth ((int) YPIX, vp_pc._pltout);

/* Don't try to compact it at all */
	for (ii = 0; ii < YPIX; ii++)
	{
	    puth ((int) 1, vp_pc._pltout);
	    RASOUT (1, XPIX, BIT, &ARRAY(ii,0));

	}
}
  




